# -*- coding: utf-8 -*-

import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from types import *

app = QApplication(sys.argv)
w = loadUi("malen.ui")
img = QImage(w.widget.width(), w.widget.height(), QImage.Format_RGB32)
img.fill(Qt.white)
imgPainter = QPainter()
painter = QPainter()

colors = [Qt.black, Qt.red, Qt.green, Qt.blue, Qt.yellow, Qt.magenta, Qt.gray]

def handleEvents(self, event):
    if event.type() in [QEvent.TouchBegin, QEvent.TouchUpdate]:
        tp = event.touchPoints()
        imgPainter.begin(img)
        for p in tp:
            c = colors[p.id() % len(colors)]
            imgPainter.setBrush(colors[p.id() % len(colors)])
            if p.state() == Qt.TouchPointMoved:
                pen = QPen(c)
                pen.setWidth(40)
                pen.setCapStyle(Qt.RoundCap)
                imgPainter.setPen(pen)
                imgPainter.drawLine(p.lastPos(), p.pos())
            #imgPainter.setPen(Qt.NoPen)
            #imgPainter.setBrush(c)
            #imgPainter.drawEllipse(p.pos(), 20, 20)
        imgPainter.end()
        self.update()
    elif event.type() == QEvent.Enter:
        self.setCursor(Qt.BlankCursor)
    elif event.type() == QEvent.Leave:
        self.setCursor(Qt.ArrowCursor)
    elif event.type() == QEvent.Paint:
        painter.begin(self)
        painter.drawImage(0, 0, img)
        painter.end()
    return True

def erase():
    img.fill(Qt.white)
    w.widget.update()

w.widget.setAttribute(Qt.WA_AcceptTouchEvents)
w.widget.event = MethodType(handleEvents, w.widget)
w.connect(w.pushButton, SIGNAL("clicked()"), erase)

w.show()
sys.exit(app.exec_())